import * as mc from '@minecraft/server';

export default class itemDataDrivenEvents {
    constructor(target, eventType) {
        this.self = target.self;
        this.other = target.other;
        if (eventType !== undefined) {
            for (let key of Object.keys(eventType)) {
                this[key](eventType[key]);
            }
        }
    }

    run_command(data) {
        let { on_entry, target } = data;
        for (let command of on_entry) {
            this[target].runCommand(command);
        }
    }

    shoot(data) {
        let { projectileId, power } = data;
        let projectile = this.self.dimension.spawnEntity(projectileId, this.self.getHeadLocation());
        let projectileComp = projectile.getComponent("minecraft:projectile");
        projectileComp.owner = this.self;
        projectileComp.shoot(
            Object.fromEntries(
                "xyz".split("").map((xyz) => [xyz, this.self.getViewDirection()[xyz] * power * 10])
            )
        );
    }
}
