import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillal', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:alastor1':
          player.runCommandAsync('execute as @s[tag=deal_active,tag=!tse,tag=!alskill3,tag=!alskill5,tag=!alskill1,tag=!alskill2,lm=20,tag=!unable_skills] at @s run function alastorskill1start');
          break;
        case 'jjba:alastor3':
          player.runCommandAsync('execute as @s[tag=deal_active,tag=!tse,tag=!alskill3,tag=!alskill5,tag=!alskill1,tag=!alskill2,lm=10,tag=!unable_skills] at @s run function alskill3start');
          break;
        case 'jjba:alastor4':
          player.runCommandAsync('execute as @s[tag=deal_active,tag=!tse,tag=!alskill4,tag=!alskill5,tag=!alskill2,lm=5,tag=!unable_skills] at @s run function alskill4start');
          break;
        case 'jjba:alastor5':
          player.runCommandAsync('execute as @s[tag=deal_active,tag=!tse,tag=!alskill3,tag=!alskill4,tag=!alskill5,tag=!alskill1,tag=!alskill2,lm=15,tag=!unable_skills] at @s run function alskill5start0');
          break;
        case 'jjba:alastor_active_control':
          player.runCommandAsync('execute as @s[tag=!tse] at @s run function alastor_active');
          break;
        case 'jjba:alastor_disabled_control':
          player.runCommandAsync('execute as @s[tag=!tse,tag=!shift] at @s run function alastor_disable');
          player.runCommandAsync('execute as @s[tag=!tse,tag=shift] at @s run function makecontract');
          break;
        case 'jjba:contract1':
          player.runCommandAsync('execute as @s[tag=!shift,tag=!unable_skills] run function makecontract1');
          player.runCommandAsync('execute as @s[tag=deal_active,tag=shift,tag=!unable_skills] run function makecontract11');
          break;
        case 'jjba:contract':
          player.runCommandAsync('execute as @s at @e[tag=!tse,type=jjba:alastor,r=2] run execute as @s at @s run function getalastor1');
          break;
        case 'jjba:summonalastor':
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 1');
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] darkness 1 1 true');
          player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user,tag=!deal,tag=!deal_active] at @s run function getalastor');
          break;
        default:
          return;
      }
    }
  });
});
