import { world, system } from "@minecraft/server";

system.runInterval(() => {
    const players = world.getAllPlayers();

    players.forEach(player => {
        if (player.hasTag("shift") && player.hasTag("bspilot1") && !player.hasTag("bspilot2")) {
            const playerDimension = player.dimension;
            const bsEntity = [...playerDimension.getEntities({ type: "jjba:bs" })][0];

            if (bsEntity) {
                let view = bsEntity.getViewDirection();
                let head = bsEntity.getHeadLocation();
                let x = head.x + 1 * view.x;
                let z = head.z + 1 * view.z;
                let y = head.y + 2 * view.y;
                let vec = { x: x, y: y, z: z };
                let rotation = bsEntity.getRotation();

                player.camera.setCamera("minecraft:free", {
                    location: vec,
                    easeOptions: { easeTime: 0.35 },
                    rotation: rotation
                });
            }
        }
    });
}, 1);
