import { world, system } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillger', {
        onUse(e) {
            const player = e.source;
            const item = e.itemStack;

            item.getComponent('minecraft:cooldown').startCooldown(player);

            switch (item.typeId) {
                case 'jjba:ger_stand_disc':
                    player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user] at @s run function ger_stand_up');
                    player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] night_vision 2 10 true');
                    player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 10');
                    break;
                case 'jjba:ge_pb_control1':
                    player.runCommandAsync('execute as @s[tag=!tse,tag=!unable_skills] at @s run function ger_pb_active');
                    break;
                case 'jjba:dbmg':
                    player.runCommandAsync('execute as @s[tag=!tse,tag=!unable_skills] at @s run function dbmg1');
                    break;
                case 'jjba:t1_nail1':
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=!unable_skills] at @s run function beam');
                    break;
                case 'jjba:ge_gflg1':
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=!tse,tag=!shift,tag=!unable_skills] at @s run function ger_gflg');
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=shift,tag=!tse,tag=!unable_skills] at @s run function ger_lf');
                    break;
                case 'jjba:ge_disabled_control1':
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=!tse] run function ger_disabled');
                    break;
                case 'jjba:t_boy_control':
                    player.runCommandAsync('execute as @s[tag=20_user,tag=!tse] at @s run function 20_boy');
                    break;
                case 'jjba:ger_cure':
                    player.runCommandAsync('execute as @s[tag=!tse] at @s run function ger_cure');
                    break;
                case 'jjba:ge_cure':
                    player.runCommandAsync('execute as @s[tag=!unable_skills] at @s run function ge_cure');
                    break;
                case 'jjba:ge_active_control1':
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=!tse] at @s run function ger_active');
                    break;
                case 'jjba:ger_control':
                    player.runCommandAsync('execute as @s[tag=ger_user,tag=!tse,tag=!unable_skills] at @s run function ger0');
                    break;
                case 'jjba:ger_cc':
                    player.runCommandAsync('function ger_cc');
                    break;
                default:
                    return;
            }
        }
    });
});
