import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skilljh', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:jh_f':
          player.runCommandAsync('execute as @s[tag=jh_user,tag=!tse,tag=!unable_skills] at @s run function jh_f');
          break;
        case 'jjba:jh_s':
          player.runCommandAsync('execute as @s[tag=jh_user,tag=!tse,tag=!jhl,tag=!unable_skills] at @s run function jh_s');
          break;
        case 'jjba:jh_l':
          player.runCommandAsync('execute as @s[tag=jh_user,tag=!tse,tag=!unable_skills] at @s run function jh_l');
          break;
        case 'jjba:jh_active_control':
          player.runCommandAsync('execute as @s[tag=jh_user,tag=!tse] at @s run function jh_active');
          break;
        case 'jjba:jh_disabled_control':
          player.runCommandAsync('execute as @s[tag=jh_user,tag=!tse,tag=!jhl] at @s run function jh_disabled');
          break;
        case 'jjba:jh_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function jh_stand_up');
          break;
        default:
          return;
      }
    }
  });
});
