import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillkcr', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:kcr_active_control':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse] at @s run function kcr_active');
          break;
        case 'jjba:kcr_disabled_control':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse] at @s run function kcr_disabled');
          break;
        case 'jjba:kc_e':
          player.runCommandAsync('execute as @s[tag=!kc_td,tag=!unable_skills] at @s run function kc_e');
          break;
        case 'jjba:kcr_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function kcr_stand_up');
          break;
        case 'jjba:kcr_e':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!shift,tag=!kcr_e_c,tag=!unable_skills] at @s run function kcr_e');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=shift,tag=!tse,tag=!kcr_e_c,tag=!unable_skills] at @s run function kcr_h');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=kcr_e_c,tag=!unable_skills] at @s run title @s actionbar "skill is on cooldown"');
          break;
        case 'jjba:kcr_fts':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!shift,tag=!kcru,tag=!kcrexplode,tag=!unable_skills] at @s run function kcr_fts');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!kcru,tag=!kcrrc,tag=shift,tag=!kcrexplode,tag=!unable_skills] at @s run function kcr_r1');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=kcrrc,tag=!kcru,tag=!unable_skills,tag=shift] at @s run title @s actionbar "skill is on cooldown"');
          break;
        case 'jjba:kcr_pb_control':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!shift,tag=!kcru,tag=!kcrexplode,tag=!unable_skills] at @s run function kcr_pb_active');
          break;
        case 'jjba:kcr_r':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!kcru,tag=!kcrrc,tag=!unable_skills] at @s run function kcr_r1');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=kcrrc,tag=!kcru,tag=!unable_skills] at @s run title @s actionbar "skill is on cooldown"');
          break;
        case 'jjba:kcr_td':
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!tse,tag=!shift,tag=!kc_td,tag=!kcruc1,tag=!unable_skills] at @s run function kcr_td');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=!kcruc1,tag=shift,tag=!tse,tag=!unable_skills] at @s run function kcr_ur');
          player.runCommandAsync('execute as @s[tag=kcr_user,tag=kcruc1,tag=!unable_skills] at @s run title @s actionbar "skill is on cooldown"');
          break;
        default:
          return;
      }
    }
  });
});
