import { Player, world } from "@minecraft/server";

function hasRequiredTags() {
    for (const player of world.getPlayers()) {
        if (player.hasTag("kcrep") && player.hasTag("kcr_active")) {
            return true;
        }
    }
    return false;
}

world.afterEvents.entityHurt.subscribe((data) => {
    if (!hasRequiredTags()) return;

    const hitPlr = data.hurtEntity;

    if (
        hitPlr.typeId === "minecraft:player" &&
        hitPlr.hasTag("kcrep") &&
        hitPlr.hasTag("kcr_active")
    ) {
        hitPlr.runCommandAsync(`function kcr_fts`);
    }
});
