import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillmih', {
        onUse(e) {
            const player = e.source;
            const item = e.itemStack;

            item.getComponent('minecraft:cooldown').startCooldown(player);

            switch (item.typeId) {
                case 'jjba:mih_sat':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!tse,tag=!mih_faer,tag=!mih_faer1,tag=!unable_skills] at @s run function mih_sat');
                    break;
                case 'jjba:mih_ta1':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!mih_faer,tag=!mih_faer1,tag=!mihta_cd,tag=!tse,tag=!unable_skills] at @s run function mih_ta');
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=mihta_cd,tag=!unable_skills] at @s run title @s actionbar "skill is on cooldown"');
                    break;
                case 'jjba:mih_sb':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!mih_faer,tag=!mih_faer1,tag=!tse,tag=!unable_skills] at @s run function mih_sb');
                    break;
                case 'jjba:mih_active_control':
                    player.runCommandAsync('execute as @s[tag=!unable_skills] at @s run function mih_active');
                    break;
                case 'jjba:mih_disabled_control':
                    player.runCommandAsync('execute as @s[tag=!unable_skills] at @s run function mih_disabled');
                    break;
                case 'jjba:mih_stand_disc':
                    player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
                    player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
                    player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function mih_stand_up');
                    break;
                case 'jjba:mih_fa':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!tse,tag=!unable_skills] at @s run function mih_fa');
                    break;
                case 'jjba:mih_fa1':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!tse,tag=!unable_skills] at @s run function mihfa1');
                    break;
                case 'jjba:mih_kh1':
                    player.runCommandAsync('execute as @s[tag=mih_user,tag=!tse,tag=!unable_skills] at @s run function mih_kh1');
                    break;
                default:
                    return;
            }
        }
    });
});
