import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillpj', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:pj_active_control':
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse] at @s run function pj_active');
          break;
        case 'jjba:pj_disabled_control':
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse] at @s run function pj_disabled');
          break;
        case 'jjba:pj_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user,tag=!ge_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user,tag=!ge_user] at @s run function pj_stand_up');
          break;
        case 'jjba:pj_cook':
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse,tag=!unable_skills] at @s run function pj_cook');
          break;
        case 'jjba:pj_cook1':
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse,tag=!unable_skills] at @s run function pj_cook1');
          break;
        case 'jjba:pj_cook2':
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse,tag=!shift,tag=!unable_skills] at @s run function pj_cook2');
          player.runCommandAsync('execute as @s[tag=pj_user,tag=!tse,tag=!unable_skills,tag=shift] at @s run function waterbottle1');
          break;
        default:
          return;
      }
    }
  });
});
