import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillscm', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:scmb':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scmb');
            break;
        case 'jjba:scms':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scms');
            break;
        case 'jjba:scmt':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scmt');
            break;
        case 'jjba:scm_active_control':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse] at @s run function scm_active');
            break;
        case 'jjba:scm_disabled_control':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse] at @s run function scm_disabled');
            break;
        case 'jjba:scmtransform':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scmtransform');
            break;
        case 'jjba:scmdino':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!scmvirus,tag=!scmcd,tag=!unable_skills] at @s run function scmvirusstart');
            player.runCommandAsync('execute as @s[tag=scmcd,tag=!unable_skills] at @s run title @s actionbar "skill is on cooldown"');
            break;
        case 'jjba:scm_stand_disc':
            player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
            player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
            player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function scm_stand_up');
            break;
        case 'jjba:scmbite':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scmtailstart');
            break;
        case 'jjba:scmroar':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse,tag=!unable_skills] at @s run function scmroarstart');
            break;
        case 'jjba:scm21':
            player.runCommandAsync('execute as @s[tag=scm_user,tag=!tse] at @s run function scm21');
            break;
        default:
            return;
      }
    }
  });
});
