import { world, system } from "@minecraft/server";

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.hasTag("scr_pilot")) {
            const velocity = player.getVelocity();
            const isMoving = velocity.x !== 0 || velocity.y !== 0 || velocity.z !== 0;

            if (isMoving) {
                player.runCommandAsync(
                    `execute at @a[tag=scr_user] run playsound scr_walk @a[r=10] ${player.location.x} ${player.location.y} ${player.location.z}`
                ).catch((error) => {
                    console.warn(`Failed to run command: ${error}`);
                });
            }
        }
    }
}, 20);
