import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillsff', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:morbius_strip':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse,tag=!unable_skills] at @s run function morbius_strip');
            break;
        case 'jjba:sf_bd':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse,tag=!unable_skills] at @s run function sf_bd');
            break;
        case 'jjba:sf_m1':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!shift,tag=!tse,tag=!unable_skills] at @s run function sf_m1');
            player.runCommandAsync('execute as @s[tag=sff_user,tag=shift,tag=!tse,tag=!unable_skills] at @s run function m2');
            break;
        case 'jjba:sf_r':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse,tag=!unable_skills] at @s run function sf_r');
            break;
        case 'jjba:sf_trap':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse,tag=!unable_skills] at @s run function sf_trap');
            break;
        case 'jjba:sff_active_control':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse] at @s run function sff_active');
            break;
        case 'jjba:sff_disabled_control':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse] at @s run function sff_disabled');
            break;
        case 'jjba:sff_stand_disc':
            player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
            player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
            player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function sff_stand_up');
            break;
        case 'jjba:sff_pb_control':
            player.runCommandAsync('execute as @s[tag=sff_user,tag=!tse,tag=!unable_skills] at @s run function sff_pb');
            break;
        default:
            return;
      }
    }
  });
});
