import { world, system } from "@minecraft/server";

system.runInterval(() => {
    let sfbdPlayerExists = false;
    let sfbd0EntityExists = false;
    let playerDimension = null;

    for (const player of world.getPlayers()) {
        if (player.hasTag("sfbd")) {
            sfbdPlayerExists = true;
            playerDimension = player.dimension;
            break;
        }
    }

    if (playerDimension) {
        for (const entity of playerDimension.getEntities()) {
            if (entity.hasTag("sfbd0")) {
                sfbd0EntityExists = true;
                break;
            }
        }
    }

    if (sfbdPlayerExists && !sfbd0EntityExists) {
        world.afterEvents.entityHurt.subscribe((data) => {
            const hit = data.hurtEntity;
            const dmg = data.damageSource.damagingEntity;

            if (
                hit.typeId === "minecraft:player" &&
                hit.hasTag("sfbd") &&
                dmg &&
                !dmg.hasTag("stand") &&
                !dmg.typeId.startsWith("minecraft:projectile")
            ) {
                dmg.addTag("sfbd0");
            }
        });
    }
}, 2);
