import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skillsk', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:sk_pb_control':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!sk311,tag=!unable_skills] at @s run function sk_pb_active');
          break;
        case 'jjba:skg1':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!skgg,tag=!unable_skills] at @s run function skgstart');
          break;
        case 'jjba:sk3':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!skgg,tag=!unable_skills] at @s run function sk3start');
          break;
        case 'jjba:sk_active_control':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse] at @s run function sk_active');
          break;
        case 'jjba:sk_disabled_control':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse] at @s run function sk_disabled');
          break;
        case 'jjba:skblock':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!unable_skills,tag=!sk311,tag=!skb1] at @s run function skbstart');
          break;
        case 'jjba:skblock1':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!unable_skills,tag=!sk311] at @s run function skbstart');
          break;
        case 'jjba:sk_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function sk_stand_up');
          break;
        case 'jjba:skfire':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!unable_skills] at @s run function skfirestart');
          break;
        case 'jjba:skfire1':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!tse,tag=!unable_skills] at @s run function skfirestart');
          break;
        case 'jjba:skg':
          player.runCommandAsync('execute as @s[tag=sk_user,tag=!unable_skills,tag=!tse,tag=!skgg,tag=!sk311] at @s run function skgstart');
          break;
        default:
          return;
      }
    }
  });
});
