import { world, system } from "@minecraft/server";

system.runInterval(() => {
    const playersWithKissTag = [...world.getPlayers()].filter(player => player.hasTag("kiss"));

    if (playersWithKissTag.length > 0) {
        for (const player of playersWithKissTag) {
            const entitiesInDimension = player.dimension.getEntities();
            
            for (const entity of entitiesInDimension) {
                if (entity.hasTag("sticker")) {
                    if (isPlayer(entity)) {
                        summonCloneEntity(entity, "jjba:kissclone");
                    } else {
                        summonCloneEntity(entity, entity.typeId);
                    }
                    entity.removeTag("sticker");
                }
            }
        }
    }
});

function summonCloneEntity(entity, typeId) {
    const entityLocation = entity.location;
    const cloneEntity = entity.dimension.spawnEntity(typeId, entityLocation);
    cloneEntity.addTag("sticker1");
}

function isPlayer(entity) {
    return world.getPlayers().some(player => player.id === entity.id);
}
