import { world, system, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('jjba:use_skilltwoh', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      item.getComponent('minecraft:cooldown').startCooldown(player);

      switch (item.typeId) {
        case 'jjba:tw_active_control1':
          player.runCommandAsync('execute as @s[tag=tw_user1] at @s run function tw_active1');
          break;
        case 'jjba:tw_disabled_control1':
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=!shift] at @s run function tw_disabled1');
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=shift] at @s run function m3');
          break;
        case 'jjba:twoh_stand_disc':
          player.runCommandAsync('effect @s[tag=!stand_user] blindness 1 10');
          player.runCommandAsync('effect @s[tag=!stand_user] night_vision 2 10 true');
          player.runCommandAsync('execute as @s[tag=!stand_user] at @s run function tw_stand_up1');
          break;
        case 'jjba:twoh_m1':
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=!shift,tag=!unable_skills] at @s run function twoh_m1');
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=shift,tag=!unable_skills] at @s run function m4');
          break;
        case 'jjba:tw_cc3':
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=!shift,tag=!unable_skills] at @s run function tw_cc3');
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=shift,tag=!unable_skills] at @s run function twoh_heal');
          break;
        case 'jjba:tw_fts1':
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=!unable_skills,tag=!shift] at @s run function tw_fts1');
          player.runCommandAsync('execute as @s[tag=tw_user1,tag=shift,tag=!unable_skills] at @s run function twohdf');
          break;
        case 'jjba:tw_pb_control1':
          player.runCommandAsync('execute as @s[tag=!tse,tag=!unable_skills] run function tw_pb_active1');
          break;
        case 'jjba:tw_ts1':
          player.runCommandAsync('execute as @s[tag=twoh_user,tag=!tse,tag=!shift,tag=!unable_skills] at @s run function tw_ts1_r');
          player.runCommandAsync('execute as @s[tag=twoh_user,tag=!tse,tag=shift,tag=!unable_skills] at @s run function twoh_bd0');

          system.runTimeout(() => {
            player.runCommandAsync('execute as @s[tag=twoh_user] at @s run function tw_ts_notitle1');
          }, 220);
          break;
        default:
          return;
      }
    }
  });
});
