import { world, system } from "@minecraft/server";

world.beforeEvents.chatSend.subscribe(async (data) => {
    const player = data.sender;
    const message = data.message.toLowerCase();

    const variations = [
        "wou", "wonder of you", "wonderofyou", "wonder ofyou", "wonder_of_you",
        "wonder_ofyou", "wonder-of-you", "wonderof you", "woy", "winder of you",
        "wounder of you", "wonder of yuo", "wndr of you", "wonder oof you",
        "w.o.y", "wonderof You", "wonder of You", "wonder Of You", "wonder ofyou",
        "wonder-of-You", "wonder-ofyou", "wonder_Of_You", "wonder_ofyou", "wonder of you",
        "wonder Of_you", "Wonder of You", "Wonder ofyou", "Wonder of You", "WonderOfYou",
        "Wonder-of-You", "Wonder_of_You", "WonderOf_you", "Wonder-Of-You", "Wonder_Of_You",
        "Wonderof You", "Wonder_Of_You", "Wonder oof You", "Wonder of you", "Wonder_Of_you",
        "Wonder-Of-You", "Wonder_of_you", "Wonder-Of-you", "WinderOfYou", "Wounder_Of_You",
        "Wndr_of_you", "W.O.Y", "W.O.y", "W.o.Y", "W.o.y", "wou", "WOU", "WoU", "WOu", 
        "wOu", "wOU", "Wou", "WOu",
        "wonder of you", "wOnder of you", "woNder of you", "wonDer of you", "wondEr of you",
        "wondeR of you", "wonder Of you", "wonder of You", "wonder of yOu", "wonder of yoU",
        "Wonder of you", "Wonder of You",
        "wonder of u", "wOnder of u", "woNder of u", "wonDer of u", "wondEr of u", "wondeR of u",
        "wonder Of u", "wonder of U", "Wonder of u", "Wonder of U",
        "woy", "WOY", "Woy", "wOy", "woY",
        "head doctor", "hEad doctor", "heAd doctor", "heaD doctor", "head Doctor",
        "head dOctor", "head doCtor", "head docTor", "head doctOr", "head doctoR",
        "войу", "вондер оф ю", "вондер офю", "вондер_оф_ю",
        "вондер_офю", "вондер-оф-ю", "вондероф ю", "вою", "виндер оф ю",
        "воундер оф ю", "вондер оф юо", "вндр оф ю", "воондер оф ю",
        "в.о.ю", "вондероф ю", "вондер оф ю", "вондер офю",
        "вондер-оф-ю", "вондер-офю", "вондер_оф_ю", "вондер оф ю",
        "вондер оф_ю", "вондер оф ю", "вондерофю", "вою", "ВОЮ",
        "вондер-Оф-ю", "вондер-оф_ю", "вондер-Оф_Ю", "ВОю",
        "ВО_ю", "В.О.Ю", "в.О.ю", "ВОЮ",
        "вондер оф у", "вондер оф ю", "вондерофю",
        "вою", "ВОЮ", "воЮ", "ВОЮ",
        "главный врач", "ГЛАВНЫЙ ВРАЧ", "главныйврач", "главный ВрАЧ", "главный враЧ",
        "ГЛавНыЙ врач", "глав врач", "ГЛАВ ВРАЧ"
    ];

    const hasTag = (await player.getTags()).includes('WOY_user');

    if (!hasTag) {
        const normalizedMessage = message.toLowerCase();

        if (variations.some(variation => normalizedMessage.includes(variation))) {
            player.sendMessage("§l§e§k|||§r§l §4Wou: Calamity approaches. Even though I warned you to stop... The chain of death will start with you §e§k|||§r");
            player.runCommandAsync("function woypassive1");

            system.runTimeout(() => {
                player.runCommandAsync("function woypassive2");
            }, 100);

            system.runTimeout(() => {
                player.runCommandAsync("function woypassive3");
                player.sendMessage("§l§e§k|||§r§l §4Wou: Safety first §e§k|||§r");
            }, 200);
        }
    }
});
